"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OPTIONAL_STATE_TYPES = exports.FIXED_STATE_TYPES = void 0;
var _types = require("./types");
const OPTIONAL_STATE_TYPES = exports.OPTIONAL_STATE_TYPES = {
  numeric: {
    regex: /^\d$/,
    name: _types.StateName.numeric,
    typeString: "[9]"
  },
  literal: {
    regex: /^[A-Za-z]$/,
    name: _types.StateName.literal,
    typeString: "[a]"
  },
  alphaNumeric: {
    regex: /^[A-Za-z0-9]$/,
    name: _types.StateName.alphaNumeric,
    typeString: "[-]"
  }
};
const FIXED_STATE_TYPES = exports.FIXED_STATE_TYPES = {
  literal: {
    regex: /^[A-Za-z]$/,
    name: _types.StateName.literal,
    typeString: "[A]"
  },
  numeric: {
    regex: /^\d$/,
    name: _types.StateName.numeric,
    typeString: "[0]"
  },
  alphaNumeric: {
    regex: /^[A-Za-z0-9]$/,
    name: _types.StateName.alphaNumeric,
    typeString: "[_]"
  }
};
//# sourceMappingURL=constants.js.map