"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _useMaskedTextInputListener = _interopRequireDefault(require("../../hooks/useMaskedTextInputListener"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
const MaskedTextInput = /*#__PURE__*/(0, _react.forwardRef)(({
  affinityCalculationStrategy,
  affinityFormat,
  autocomplete = true,
  autoSkip = false,
  customNotations,
  isRTL = false,
  mask,
  autoCapitalize = "words",
  allowedKeys,
  defaultValue,
  onChange,
  onChangeText,
  onTailPlaceholderChange,
  onFocus,
  renderTextInputComponent,
  validationRegex,
  ...rest
}, ref) => {
  const InputComponent = renderTextInputComponent ?? _reactNative.TextInput;
  const inputRef = (0, _react.useRef)(null);
  const {
    defaultValue: maskedDefaultValue,
    handleFocus,
    handleOnChange,
    setTextField
  } = (0, _useMaskedTextInputListener.default)({
    mask,
    affinityFormat,
    affinityCalculationStrategy,
    customNotations,
    allowedKeys,
    autocomplete,
    autoSkip,
    isRTL,
    onChange,
    onChangeText,
    onTailPlaceholderChange,
    onFocus,
    validationRegex,
    defaultValue
  });
  (0, _react.useImperativeHandle)(ref, () => {
    setTextField(inputRef.current);
    return inputRef.current;
  }, [setTextField, inputRef]);
  return /*#__PURE__*/_react.default.createElement(InputComponent, _extends({
    ref: inputRef,
    autoCapitalize: autoCapitalize,
    defaultValue: maskedDefaultValue,
    onChange: handleOnChange,
    onFocus: handleFocus
  }, rest));
});
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(MaskedTextInput);
//# sourceMappingURL=index.js.map