import { AFFINITY_CALCULATION_STRATEGY } from "../enums";
import Mask from "./helper/Mask";
import CaretString from "./model/CaretString";
import type { Notation } from "../types";
import type { MaskResult } from "./model/types";
import type { NativeSyntheticEvent, TextInputChangeEventData, TextInputFocusEventData } from "react-native";
type Field = HTMLInputElement;
declare class MaskedTextChangedListener {
    primaryFormat: string;
    affineFormats: string[];
    customNotations: Notation[];
    affinityCalculationStrategy: AFFINITY_CALCULATION_STRATEGY;
    autocomplete: boolean;
    autoskip: boolean;
    rightToLeft: boolean;
    textField: Field | null;
    allowedKeys: string;
    autocompleteOnFocus?: boolean;
    defaultValue?: string;
    private validationRegex?;
    private afterText;
    constructor(primaryFormat: string, affineFormats?: string[], customNotations?: Notation[], affinityCalculationStrategy?: AFFINITY_CALCULATION_STRATEGY, autocomplete?: boolean, autoskip?: boolean, rightToLeft?: boolean, allowedKeys?: string, validationRegex?: string, autocompleteOnFocus?: boolean, defaultValue?: string);
    get primaryMask(): Mask;
    setText(text: string, autocomplete?: boolean): void;
    setAllowedKeys: (allowedKeys: string) => void;
    get placeholder(): string;
    get acceptableTextLength(): number;
    get totalTextLength(): number;
    get acceptableValueLength(): number;
    get totalValueLength(): number;
    setTextField: (textField: Field) => void;
    handleTextChange: (event: NativeSyntheticEvent<TextInputChangeEventData>) => MaskResult;
    private prepareText;
    private isValidText;
    private setDefaultText;
    handleFocus: (event: NativeSyntheticEvent<TextInputFocusEventData>) => void;
    pickMask: (text: CaretString) => Mask;
    setValidationRegex: (validationRegex?: string) => void;
    getValidationRegex: () => string | undefined;
    private maskGetOrCreate;
    private calculateAffinity;
}
export default MaskedTextChangedListener;
//# sourceMappingURL=AdvancedTextInputMaskListener.d.ts.map